def magic_square_exam(sol, s):
    n = len(sol)

    # Проверка горизонталей
    for i in range(n):
        if sum(sol[i]) != s:
            return False

    # Проверка вертикалей
    arr = [True if sum(x) - s == 0 else False for x in zip(*sol)]
    if not all(arr):
        return False

    # Проверка главной диагонали
    a = sum([sol[i][i] for i in range(n)])
    if a - s != 0:
        return False

    # Проверка побочной диагонали
    a = sum([sol[i][n - i - 1] for i in range(n)])
    if a - s != 0:
        return False
    return True

def magic_all_sol(i, sol, s):
    n = len(sol)

    # Проверка, является ли частичное решение полным
    if magic_square_exam(sol, s):
        print_square(sol)  # вывод решения
    else:

        # Генерация всех возможных вариантов,
        # которые могут бы быть представлены в частичном решении
        for k_row in range(0, n):
            for k_col in range(0, n):

                # Проверка, является ли
                # k-е решение валидным
                if sol[k_row][k_col] == 0:

                    # Помещение k-го кандидата в частичное решение
                    sol[k_row][k_col] = i

                    # Рекурсивный вызов, чтобы включить
                    # больше кандидатов в частичное решение
                    magic_all_sol(i + 1, sol, s)

                    # Исключение k-го кандидата из частичного
                    # решения, и восстановление структур данных с
                    # указанием того, что k-го кандидата больше
                    # нет в частичном решении
                    sol[k_row][k_col] = 0


def magic_square(n):
    sol = [0] * n
    s = n * (n * n + 1) / 2
    # Создаем список списков, заполненный нулями
    sol = [sol[:] for _ in range(n)]
    magic_all_sol(1, sol, s)


def print_square(sol):
    for i in range(len(sol)):
        print(*sol[i])
    print()


magic_square(3)
# magic_square(4)
